import React from 'react';
import hoistNonReactStatics from 'hoist-non-react-statics';
var ReactRouterContext = React.createContext({});

ReactRouterContext.wrapper = function (Component, displayName) {
  var WrappedComponent = function WrappedComponent(props) {
    return React.createElement(ReactRouterContext.Consumer, null, function (context) {
      return React.createElement(Component, Object.assign({}, context, props));
    });
  };

  WrappedComponent.displayName = Component.displayName || displayName;
  return hoistNonReactStatics(WrappedComponent, Component);
};

export default ReactRouterContext;