import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useState, useEffect } from 'react';
import { func, object } from 'prop-types';
import { routes, component, components } from './InternalPropTypes';
import { createTransitionManager } from './createTransitionManager';
import { fromReactTreeToJSON } from '../lib/utils/react-utils';
import { createRouterObject } from './utils/RouterUtils';
import RRContext from './ReactRouterContext';

var Router = function Router(_ref) {
  var _ref2, _ref3;

  var components = _ref.components,
      children = _ref.children,
      routes = _ref.routes,
      render = _ref.render,
      matchContext = _ref.matchContext,
      params = _ref.params,
      history = _ref.history,
      onError = _ref.onError,
      props = _objectWithoutPropertiesLoose(_ref, ["components", "children", "routes", "render", "matchContext", "params", "history", "onError"]);

  var transitionManager = (_ref2 = matchContext === null || matchContext === void 0 ? void 0 : matchContext.transitionManager) !== null && _ref2 !== void 0 ? _ref2 : createTransitionManager({
    history: history,
    jsonRoutes: fromReactTreeToJSON(routes)
  });
  var router = (_ref3 = props === null || props === void 0 ? void 0 : props.router) !== null && _ref3 !== void 0 ? _ref3 : createRouterObject(history, transitionManager, {
    location: null,
    routes: null,
    params: null
  });

  var _useState = useState({
    router: router,
    params: params,
    components: components
  }),
      state = _useState[0],
      setState = _useState[1];

  useEffect(function () {
    var unlisten = matchContext.transitionManager.listen(function (err, nextState) {
      if (err) {
        if (onError) {
          return onError(err);
        }

        throw err;
      }

      var params = nextState.params,
          components = nextState.components,
          location = nextState.location;

      var nextRouter = _objectSpread({}, state.router, {
        params: params,
        location: location,
        routes: routes
      });

      setState({
        router: nextRouter,
        params: params,
        components: components
      });
    });
    return function () {
      return unlisten();
    };
  }, []); // eslint-disable-line

  return React.createElement(RRContext.Provider, {
    value: {
      router: state.router,
      params: state.params
    }
  }, render({
    components: state.components,
    params: state.params,
    router: state.router,
    props: props
  }));
};

Router.displayName = 'Router';
Router.defaultProps = {
  render: function render(_ref4) {
    var components = _ref4.components,
        params = _ref4.params,
        router = _ref4.router,
        props = _ref4.props;

    var pipeReact = function pipeReact(components) {
      return function (base) {
        return components.reduceRight(function (acc, component) {
          return React.createElement(component, _objectSpread({}, props, {
            params: params,
            router: router,
            children: acc
          }));
        }, base);
      };
    };

    var tree = pipeReact(components)(null);
    return tree;
  }
};
export default Router;